/**
  *  \file game/talliance.h
  *  \brief THost alliance handling
  *
  *  (c) 2001-2015 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_GAME_TALLIANCE_H
#define PCC_V2_GAME_TALLIANCE_H

#include "game/alliance.h"
#include "cpluslib/types.h"

class GCommandContainer;

/** Implementation of Alliances for THost.
    This is set up using callouts from the message parser. */
class GTHostAllianceHandler : public GAllianceHandler {
 public:
    GTHostAllianceHandler(GCommandContainer& commands);

    virtual void postprocess(GAlliances& allies);
    virtual void handleChanges(const GAlliances&);

    static void processVersion(GCommandContainer& cmd, GAlliances& alliances, uint32_t version);

 private:
    GCommandContainer& commands;
};

#endif
